////////////////////////////////////////////////
// Game PacMan Humry
// Code by faceH0r 19.03.2005
////////////////////////////////////////////////

#pragma comment(lib,"opengl32.lib")
#pragma comment(lib,"glu32.lib")
#pragma comment(lib,"glaux.lib")

#pragma comment(lib,"fmodvc.lib")

#include <stdio.h>

#include <windows.h>

#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>

#include <fmod/fmod.h>

// My class string
class CSTRING{
public:
	char m_String[256];

	int GetLength(){
		int i=0;

		while(m_String[i]!=0)i++;

		return i;
	}

	bool operator==(CSTRING two){	
		int i=two.GetLength();
		bool equ=true;
		int j=0,length=0;

		while(m_String[length]!=0)length++;

		if(i==length){
			while(j<i&&equ){
				if(m_String[j]!=two.m_String[j])equ=false;
				j++;
			}
		}else return false;

		return equ;
	}

	bool operator+(char *addc){
		int length=0,length1=0;

		while(m_String[length]!=0)length++;
		while(addc[length1]!=0)length1++;

		for(int i=0;i<length1;i++)
			m_String[length+i]=addc[i];
		m_String[length+length1]=0;
	}

	operator=(char *equ){
		int i=0;

		while(equ[i]!=0){
			m_String[i]=equ[i];
			i++;
		}

		m_String[i]=0;
	}

	int GetPos(char sym){
		int length=0;

		while(m_String[length]!=0)length++;
		for(int i=0;i<length;i++)
			if(m_String[i]==sym)return i;

		return -1;
	}
private:
};

class CTEXTURE{
public:
	GLuint textures[50];
	int it;

	void AddTexture(char *name){
		AUX_RGBImageRec *tl;

		it++;
		tl=auxDIBImageLoad(name);
		glGenTextures(1,&textures[it]);
		glBindTexture(GL_TEXTURE_2D,textures[it]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		gluBuild2DMipmaps(GL_TEXTURE_2D,3,tl->sizeX,tl->sizeY,GL_RGB,GL_UNSIGNED_BYTE,tl->data);
	}

	void CallTexture(int nmb){
		glBindTexture(GL_TEXTURE_2D,textures[nmb]);
	}
private:
};

struct SOBJECT{
	int x,y,tex,tt;
	float angle,time,timebon,xf,yf,xs,ys,anit,t_Death;
	bool die,bon,keys[256],perw,pera,pers,perd;
	bool s_win,s_lose;
};

HGLRC hRc;
HDC hDc;

SOBJECT game_Pacman,game_Monster[3];
int c_Eat=0,c_Monster,n_Lvl=1,c_Lvl=0,live_Pacman=3;
CTEXTURE game_Texture;
int map[361],game_Scores,game_SScores;
bool game_Pause=false,b_chg=false;
CSTRING namelevels[15];
DEVMODE dm;
// Settings monsters
	float m_Speed,m_RespSpeed;
	int m_TexNmb[3];
// Font
	int base[4];
// Menu
	bool g_Menu;
	bool g_Credits;
	bool g_Scores;
// Sounds
	FSOUND_STREAM *s_Stream[4];
// Game
	bool g_LeftButton;
	float t_LeftButton;
// Scores
	int a_Scores,a_Frags,a_Levels;

// Forwards
void Reload();

void LoadScores(char *name){
	FILE *infile;

	infile=fopen(name,"r");
	if(infile!=0){
			fscanf(infile,"%d %d %d",&a_Scores,&a_Frags,&a_Levels);
		fclose(infile);
	}else
		MessageBox(0,"Scores.ini not found!","Error!",0);
}

void SaveScores(char *name){
	FILE *infile;

	infile=fopen(name,"w");
		fprintf(infile,"%d\n %d\n %d",a_Scores,a_Frags,a_Levels);
	fclose(infile);
}


void BuildFont(int nmb,int size){
	HFONT font;									

	base[nmb]=glGenLists(96);

	font=CreateFont(size,0,0,0,FW_BOLD,0,0,0,0,0,0,0,0,"Courier New");

	SelectObject(hDc,font);
	wglUseFontBitmaps(hDc,32,96,base[nmb]);
}

void glPrint(int nmb,char *fmt,...){
	char text[256];
	va_list ap;
	
	va_start(ap,fmt);
		vsprintf(text,fmt,ap);					
	va_end(ap);

	glListBase(base[nmb]-32);
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
}

void DestroyFont(int nmb){
	glDeleteLists(base[nmb],96);
}

bool TestStartPoint(){
	for(int j=0;j<19;j++)
		for(int i=0;i<19;i++)
			if(map[j*19+i]==9){
				game_Pacman.x=i;
				game_Pacman.y=j;
				game_Pacman.xf=game_Pacman.x;
				game_Pacman.yf=game_Pacman.y;
				return true;
			}

	return false;
}

PrintText(int nmb,float x,float y,float r,float g,float b,char *t,int i){
	glDisable(GL_TEXTURE_2D);
	glColor3f(r,g,b);
	glRasterPos2f(x,y);
	glPrint(nmb,t,i);
}

void LoadLevel(char *name){
	FILE *infile;
	int i,ii[2];
	int c_Read[2];

	// Load level and coordinates objects
	infile=fopen(name,"r");
	if(infile==0)								// File not found
		MessageBox(0,"Not found level","Error",0);

	for(i=0;i<361;i++)fscanf(infile,"%d",&map[i]);		// Load map level
	if(TestStartPoint()==false)
			MessageBox(0,"Not found start point","Error!",0);
	fscanf(infile,"%d",&c_Monster);				// Read count monsters
	for(i=0;i<c_Monster;i++){					// Loop load monsters
		fscanf(infile,"%d %d",&ii[0],&ii[1]);
		game_Monster[i].xs=ii[0];
		game_Monster[i].ys=ii[1];
		game_Monster[i].x=game_Monster[i].xs;
		game_Monster[i].y=game_Monster[i].ys;
		game_Monster[i].xf=game_Monster[i].x;
		game_Monster[i].yf=game_Monster[i].y;
		game_Monster[i].perd=false;
		game_Monster[i].perw=false;
		game_Monster[i].pera=false;
		game_Monster[i].pers=false;
	}

	// Close file
	fclose(infile);
}

void SetDCPixelFormat(HDC hDc){
	PIXELFORMATDESCRIPTOR pfd;
	int nPixelFormat;

	memset(&pfd,0,sizeof(PIXELFORMATDESCRIPTOR));
	pfd.dwFlags=PFD_DOUBLEBUFFER|PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL;
	nPixelFormat=ChoosePixelFormat(hDc,&pfd);
	SetPixelFormat(hDc,nPixelFormat,&pfd);
}

void DrawRect(float x1,float y1,float x2,float y2){
	glDisable(GL_TEXTURE_2D);
	glColor3f(0.2,0.2,0.2);
	glLineWidth(5);
	glBegin(GL_LINE_LOOP);
		glVertex2f(x1,y1);
		glVertex2f(x1,y2);
		glVertex2f(x2,y2);
		glVertex2f(x2,y1);
	glEnd();
}

void DrawBox(float x,float y,float angle,int type,int tex){
	int sr[2]={GL_DST_COLOR,GL_ONE};
	int ds[2]={GL_ZERO,GL_ONE};

	glEnable(GL_TEXTURE_2D);
	glColor3f(1,1,1);
	glEnable(GL_BLEND);
	glPushMatrix();
	glTranslatef(-0.9+(float)1.9/19*x,-0.9+(float)1.9/19*y,0);
	glRotatef(angle,0,0,1);
	for(int i=0;i<2;i++){
		game_Texture.CallTexture(tex+1-i);
		glBlendFunc(sr[i],ds[i]);
		glBegin(GL_QUADS);
			if(angle!=180)glTexCoord2d(0,0);
			else glTexCoord2d(0,1);
			glVertex2f(-0.05,-0.05);
			if(angle!=180)glTexCoord2d(0,1);
			else glTexCoord2d(0,0);
			glVertex2f(-0.05,0.05);
			if(angle!=180)glTexCoord2d(1,1);
			else glTexCoord2d(1,0);
			glVertex2f(0.05,0.05);
			if(angle!=180)glTexCoord2d(1,0);
			else glTexCoord2d(1,1);
			glVertex2f(0.05,-0.05);
		glEnd();
	}
	glPopMatrix();
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}

void CenterPrint(int tex){
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	game_Texture.CallTexture(tex+1);
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	glBegin(GL_QUADS);
		glTexCoord2d(0,0);
		glVertex2f(-0.2,-0.2);
		glTexCoord2d(0,1);
		glVertex2f(-0.2,0.2);
		glTexCoord2d(1,1);
		glVertex2f(0.2,0.2);
		glTexCoord2d(1,0);
		glVertex2f(0.2,-0.2);
	glEnd();
	glBlendFunc(GL_ONE,GL_ONE);
	game_Texture.CallTexture(tex);
	glBegin(GL_QUADS);
		glTexCoord2d(0,0);
		glVertex2f(-0.2,-0.2);
		glTexCoord2d(0,1);
		glVertex2f(-0.2,0.2);
		glTexCoord2d(1,1);
		glVertex2f(0.2,0.2);
		glTexCoord2d(1,0);
		glVertex2f(0.2,-0.2);
	glEnd();
	glDisable(GL_BLEND);
}

void DrawLevel(){
	for(int j=0;j<19;j++)
		for(int i=0;i<19;i++){
			if(map[j*19+i]==1)DrawBox(i,j,0,0,13);
			if(map[j*19+i]==2)DrawBox(i,j,0,0,15);
			if(map[j*19+i]==3)DrawBox(i,j,0,0,17);
		}
}

void DrawCross(float x,float y){
	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	game_Texture.CallTexture(17);
	glBegin(GL_QUADS);
		glTexCoord2d(0,0);
		glVertex2d(x-0.05,y-0.05);
		glTexCoord2d(0,1);
		glVertex2d(x-0.05,y+0.05);
		glTexCoord2d(1,1);
		glVertex2d(x+0.05,y+0.05);
		glTexCoord2d(1,0);
		glVertex2d(x+0.05,y-0.05);
	glEnd();
}

bool TestXY(float x,float y,float x0,float y0,float x1,float y1){
	if(x>=x0&&x<=x1&&y>=y0&&y<=y1)
		return true;

	return false;
}

void DrawMenu(bool draw,float xc,float yc){
	POINT mpos;

	if(draw){
		glColor3f(1,1,1);
		glEnable(GL_TEXTURE_2D);
		game_Texture.CallTexture(50);
		glBegin(GL_QUADS);
			glTexCoord2d(0,0);
			glVertex2d(-1,-1);
			glTexCoord2d(0,1);
			glVertex2d(-1,1);
			glTexCoord2d(1,1);
			glVertex2d(1,1);
			glTexCoord2d(1,0);
			glVertex2d(1,-1);
		glEnd();

		GetCursorPos(&mpos);

		if(g_Credits==false&&g_Scores==false){
			if(TestXY(-1+(float)mpos.x/(dm.dmPelsWidth/2),1-(float)mpos.y/(dm.dmPelsHeight/2),0.4,0.1,0.9,0.2)){
				PrintText(1,0.4,0.1,1,0,0,"New Game",0);
				if(g_LeftButton){
					game_Pacman.die=true;
					live_Pacman=-1;
					Reload();
					g_Menu=false;
				}
			}else PrintText(1,0.4,0.1,0.5,0,0,"New Game",0);
			if(TestXY(-1+(float)mpos.x/(dm.dmPelsWidth/2),1-(float)mpos.y/(dm.dmPelsHeight/2),0.4,-0.15,0.75,-0.05)){
				PrintText(1,0.4,-0.15,1,0,0,"Scores",0);
				if(g_LeftButton)g_Scores=true;
			}
			else PrintText(1,0.4,-0.15,0.5,0,0,"Scores",0);
			if(TestXY(-1+(float)mpos.x/(dm.dmPelsWidth/2),1-(float)mpos.y/(dm.dmPelsHeight/2),0.4,-0.4,0.85,-0.3)){
				PrintText(1,0.4,-0.4,1,0,0,"Credits",0);
				if(g_LeftButton)g_Credits=true;
			}else PrintText(1,0.4,-0.4,0.5,0,0,"Credits",0);
			if(TestXY(-1+(float)mpos.x/(dm.dmPelsWidth/2),1-(float)mpos.y/(dm.dmPelsHeight/2),0.4,-0.65,0.65,-0.55)){
				PrintText(1,0.4,-0.65,1,0,0,"Exit",0);
				if(g_LeftButton){
					a_Scores+=game_Scores;
					SaveScores("Scores.ini");
					PostQuitMessage(0);
				}
			}else PrintText(1,0.4,-0.65,0.5,0,0,"Exit",0);
			PrintText(2,-0.25,-0.95,0.5,0,0,"Created by faceH0r 2005",30);
		}else
		if(g_Credits){
			if(g_LeftButton&&t_LeftButton>10){
				g_Credits=false;
				t_LeftButton=0;
			}
			PrintText(1,0.3,0.2,0.4,0,0,"Credits",0);
			PrintText(0,0.2,0,0.5,0,0,"Main programmer:",0);
			PrintText(0,0.35,-0.075,0.5,0,0,"faceH0r",0);
			PrintText(0,0.2,-0.2,0.5,0,0,"Level designers:",0);
			PrintText(0,0.35,-0.275,0.5,0,0,"faceH0r",0);
			PrintText(0,0.35,-0.35,0.5,0,0,"jnz",0);
			PrintText(0,0.2,-0.475,0.5,0,0,"Special thanks to:",0);
			PrintText(0,0.35,-0.55,0.5,0,0,"DiV",0);
			PrintText(0,0.35,-0.625,0.5,0,0,"Tiandong",0);
		}else 
		if(g_Scores){
			if(g_LeftButton&&t_LeftButton>10){
				g_Scores=false;
				t_LeftButton=0;
			}
			PrintText(1,0.3,0.2,0.4,0,0,"Scores",0);
			PrintText(0,0.2,0,0.5,0,0,"All scores:",0);
			PrintText(0,0.35,-0.075,0.5,0,0,"%d",a_Scores);
			PrintText(0,0.2,-0.2,0.5,0,0,"Count frags:",0);
			PrintText(0,0.35,-0.275,0.5,0,0,"%d",a_Frags);
			PrintText(0,0.2,-0.4,0.5,0,0,"Count levels:",0);
			PrintText(0,0.35,-0.475,0.5,0,0,"%d",a_Levels);
		}

		DrawCross(-1+(float)mpos.x/(dm.dmPelsWidth/2),1-(float)mpos.y/(dm.dmPelsHeight/2));
		if(t_LeftButton<15)t_LeftButton+=(float)0.1;
	}
}

bool TestPoint(int x,int y){
	if(map[x+y*19]!=1)return true;
	return false;
}

void CalculateMonster(){
	int ix[3],iy[3];

	if(game_Pacman.die==false&&c_Eat>0&&game_Pause==false&&g_Menu==false){
		for(int i=0;i<c_Monster;i++){
			if(game_Monster[i].t_Death>1){
				game_Monster[i].x=game_Monster[i].xs;
				game_Monster[i].y=game_Monster[i].ys;
				game_Monster[i].xf=game_Monster[i].x;
				game_Monster[i].yf=game_Monster[i].y;
				game_Monster[i].perd=false;
				game_Monster[i].perw=false;
				game_Monster[i].pera=false;
				game_Monster[i].pers=false;
				game_Monster[i].t_Death=0;
				game_Monster[i].die=false;
			}
			if(game_Monster[i].die==false){
				ix[i]=game_Pacman.x-game_Monster[i].x;
				iy[i]=game_Pacman.y-game_Monster[i].y;

				if(ix[i]>0&&map[game_Monster[i].y*19+game_Monster[i].x+1]!=1){
					if(game_Monster[i].pera==false&&game_Monster[i].pers==false&&game_Monster[i].perw==false)
						game_Monster[i].perd=true;
				}

				if(game_Monster[i].perd){
					if(game_Monster[i].xf<=game_Monster[i].x+1)game_Monster[i].xf+=(float)m_Speed;
					else{
						game_Monster[i].x++;
						game_Monster[i].xf=game_Monster[i].x;
						game_Monster[i].perd=false;
					}
				}

				if(ix[i]<0&&map[game_Monster[i].y*19+game_Monster[i].x-1]!=1){
					if(game_Monster[i].perw==false&&game_Monster[i].pers==false&&game_Monster[i].perd==false)
						game_Monster[i].pera=true;
				}

				if(game_Monster[i].pera){
					if(game_Monster[i].xf>=game_Monster[i].x-1)game_Monster[i].xf-=(float)m_Speed;
					else{
						game_Monster[i].x--;
						game_Monster[i].xf=game_Monster[i].x;
						game_Monster[i].pera=false;
					}
				}

				if(iy[i]>0&&map[(game_Monster[i].y+1)*19+game_Monster[i].x]!=1){
					if(game_Monster[i].pera==false&&game_Monster[i].pers==false&&game_Monster[i].perd==false)
						game_Monster[i].perw=true;
				}

				if(game_Monster[i].perw){
					if(game_Monster[i].yf<=game_Monster[i].y+1)game_Monster[i].yf+=(float)m_Speed;
					else{
						game_Monster[i].y++;
						game_Monster[i].yf=game_Monster[i].y;
						game_Monster[i].perw=false;
					}
				}

				if(iy[i]<0&&map[(game_Monster[i].y-1)*19+game_Monster[i].x]!=1){
					if(game_Monster[i].pera==false&&game_Monster[i].perw==false&&game_Monster[i].perd==false)
						game_Monster[i].pers=true;
				}

				if(game_Monster[i].pers){
					if(game_Monster[i].yf>=game_Monster[i].y-1)game_Monster[i].yf-=(float)m_Speed;
					else{
						game_Monster[i].y--;
						game_Monster[i].yf=game_Monster[i].y;
						game_Monster[i].pers=false;
					}
				}
			}else{
				game_Monster[i].t_Death+=(float)m_RespSpeed;
			}
		}
	}
}

void CalculatePacman(){
	if(game_Pause==false&&game_Pacman.die==false&&g_Menu==false){
		// Key W & UP 
		if((game_Pacman.keys['W']||game_Pacman.keys[VK_UP])&&game_Pacman.y<=18&&TestPoint(game_Pacman.x,game_Pacman.y+1)&&game_Pacman.die==false&&c_Eat>0){
			if(game_Pacman.pera==false&&game_Pacman.pers==false&&game_Pacman.perd==false){
				game_Pacman.perw=true;
				game_Pacman.angle=90;
			}
		};
		if(game_Pacman.perw){
			if(game_Pacman.yf<=game_Pacman.y+1-0.1)game_Pacman.yf+=(float)0.1;
			else{
				game_Pacman.y++;
				game_Pacman.yf=game_Pacman.y;
				game_Pacman.time=0;
				game_Pacman.perw=false;
			}
		}

		// Key S & DOWN
		if((game_Pacman.keys['S']||game_Pacman.keys[VK_DOWN])&&game_Pacman.y>=0&&TestPoint(game_Pacman.x,game_Pacman.y-1)&&game_Pacman.die==false&&c_Eat>0){
			if(game_Pacman.pera==false&&game_Pacman.perw==false&&game_Pacman.perd==false){
				game_Pacman.pers=true;
				game_Pacman.angle=-90;
			}
		}
		if(game_Pacman.pers){
			if(game_Pacman.yf>=game_Pacman.y-1+0.1)game_Pacman.yf-=(float)0.1;
			else{
				game_Pacman.y--;
				game_Pacman.yf=game_Pacman.y;
				game_Pacman.time=0;
				game_Pacman.pers=false;
			}
		}
		// Key A & LEFT
		if((game_Pacman.keys['A']||game_Pacman.keys[VK_LEFT])&&game_Pacman.x>=1&&TestPoint(game_Pacman.x-1,game_Pacman.y)&&game_Pacman.die==false&&c_Eat>0){
			if(game_Pacman.perw==false&&game_Pacman.pers==false&&game_Pacman.perd==false){
				game_Pacman.pera=true;
				game_Pacman.angle=180;
			}
		}
		if(game_Pacman.pera){
			if(game_Pacman.xf>=game_Pacman.x-1+0.1)game_Pacman.xf-=(float)0.1;
			else{
				game_Pacman.x--;
				game_Pacman.xf=game_Pacman.x;
					game_Pacman.time=0;
				game_Pacman.pera=false;
			}
		}
		// Key D & RIGHT
		if((game_Pacman.keys['D']||game_Pacman.keys[VK_RIGHT])&&game_Pacman.x<=18&&TestPoint(game_Pacman.x+1,game_Pacman.y)&&game_Pacman.die==false&&c_Eat>0){
			if(game_Pacman.pera==false&&game_Pacman.pers==false&&game_Pacman.perw==false){
				game_Pacman.perd=true;
				game_Pacman.angle=0;
			}
		}
		if(game_Pacman.perd){
			if(game_Pacman.xf<=game_Pacman.x+1-0.1)game_Pacman.xf+=(float)0.1;
			else{
				game_Pacman.x++;
				game_Pacman.xf=game_Pacman.x;
				game_Pacman.time=0;
				game_Pacman.perd=false;
			}
		}
	}
}

void TestObject(){
	if(map[game_Pacman.y*19+game_Pacman.x]==2&&game_Pacman.die==false){
		map[game_Pacman.y*19+game_Pacman.x]=0;
		c_Eat--;
		game_Scores+=(int)5;
		game_SScores+=(int)5;
	}
	if(map[game_Pacman.y*19+game_Pacman.x]==3&&game_Pacman.die==false){
		map[game_Pacman.y*19+game_Pacman.x]=0;
		c_Eat--;
		game_Pacman.bon=true;
		game_Pacman.timebon+=25;
		game_Scores+=(int)10;
		game_SScores+=(int)10;
	}
	for(int i=0;i<c_Monster;i++){
		if(game_Pacman.xf>=game_Monster[i].xf-0.5&&game_Pacman.xf<=game_Monster[i].xf+0.5&&game_Pacman.yf>=game_Monster[i].yf-0.5&&game_Pacman.yf<=game_Monster[i].yf+0.5&&game_Monster[i].die==false){
			if(game_Pacman.bon==false){
				game_Pacman.die=true;
				if(game_Pacman.s_lose==false){
					if((rand()-16384)>0)FSOUND_Stream_Play(FSOUND_FREE,s_Stream[0]);
					else FSOUND_Stream_Play(FSOUND_FREE,s_Stream[1]);
				}
				game_Pacman.s_lose=true;
			}
			else{
				a_Frags++;
				game_Monster[i].die=true;
				game_Scores+=(int)25;
				game_SScores+=(int)25;
			}
		}
	}
}

void LoadTextures(){
	FILE *pfile;

	int c_Read[2],i,j;
	char f_Name[256];
	CSTRING m_Dir[3];

	pfile=fopen("pacman.ini","r");
	if(pfile!=0){
		game_Texture.it=0;							// NULL textures
		// Load Textures of level
		fscanf(pfile,"%s",&m_Dir[0].m_String);		// Read name main directory
		fscanf(pfile,"%d",&c_Read[0]);				// Read count sub-directories

		for(j=0;j<c_Read[0];j++){					// Loop count sub-directories
			fscanf(pfile,"%s",&m_Dir[1]);			// Read name sub-directory
			fscanf(pfile,"%d",&c_Read[1]);			// Read count files
			for(i=0;i<c_Read[1];i++){				// Loop count files
				fscanf(pfile,"%s",&f_Name);		// Read filename
				m_Dir[2]=m_Dir[0].m_String;		// dir[2]="ROOT/"
				m_Dir[2]+m_Dir[1].m_String;		// dir[2]+="SUB-DIR"
				m_Dir[2]+f_Name;				// dir[2]+="FILENAME"
				game_Texture.AddTexture(m_Dir[2].m_String);		// Add texture
			}
		}
		fclose(pfile);
	}
}

void InitMonsters(char *name){
	FILE *fmon;

	fmon=fopen(name,"r");
	if(fmon==0)
		MessageBox(0,"Not found file monsters.ini","Error",0);
	else{
		fscanf(fmon,"%f %f",&m_Speed,&m_RespSpeed);
		fscanf(fmon,"%d %d %d",&m_TexNmb[0],&m_TexNmb[1],&m_TexNmb[2]);
		fclose(fmon);
	}
}

void InitPacMan(){
	FILE *ifile;
	int i;

	ifile=fopen("settings.ini","r");
	if(ifile!=0){
		fscanf(ifile,"%d",&c_Lvl);
		for(i=0;i<c_Lvl;i++)
			fscanf(ifile,"%s",&namelevels[i]);
		memset(&dm,0,sizeof(DEVMODE));
		dm.dmSize=sizeof(DEVMODE);
		fscanf(ifile,"%d",&b_chg);
		fscanf(ifile,"%d",&dm.dmBitsPerPel);
		fscanf(ifile,"%d",&dm.dmPelsWidth);
		fscanf(ifile,"%d",&dm.dmPelsHeight);
		dm.dmFields=DM_PELSHEIGHT|DM_PELSWIDTH|DM_BITSPERPEL;
		if(b_chg)ChangeDisplaySettings(&dm,CDS_FULLSCREEN);
		fclose(ifile);
	}else MessageBox(0,"Not file settings!!!","Error",0);

	LoadScores("Scores.ini");
}

void CalculateEat(){
	c_Eat=0;

	for(int i=0;i<361;i++)
		if(map[i]==2||map[i]==3)c_Eat++;			// Inc count eat
}

void Reload(){
	int i;

	if(c_Eat<=0){
		if(n_Lvl<c_Lvl)n_Lvl++;
		else n_Lvl=1;
		memset(&game_Pacman,0,sizeof(SOBJECT));		// Clear pacman settings
		for(i=0;i<c_Monster;i++)
			memset(&game_Monster[i],0,sizeof(SOBJECT));	// Clear monster rec
		LoadLevel(namelevels[n_Lvl-1].m_String);
		for(i=0;i<c_Monster;i++)
			game_Monster[i].tex=m_TexNmb[i];		// Set texture number
		CalculateEat();
		a_Levels++;
	}
	if(game_Pacman.die){							
		if(live_Pacman<=0){
			live_Pacman=3;
			game_Scores=0;
			game_SScores=0;
			n_Lvl=1;
		}else live_Pacman--;
		memset(&game_Pacman,0,sizeof(SOBJECT));		// Clear pacman settings
		for(i=0;i<c_Monster;i++)
			memset(&game_Monster[i],0,sizeof(SOBJECT));	// Clear monster rec
		LoadLevel(namelevels[n_Lvl-1].m_String);
		for(i=0;i<c_Monster;i++)
			game_Monster[i].tex=m_TexNmb[i];		// Set texture number
		CalculateEat();
	}
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	int i;

	switch(uMsg){
	case WM_LBUTTONDOWN:
		Reload();
		g_LeftButton=true;
		break;
	case WM_LBUTTONUP:
		g_LeftButton=false;
		break;
	case WM_CREATE:
		hDc=GetDC(hWnd);
		SetDCPixelFormat(hDc);
		hRc=wglCreateContext(hDc);
		wglMakeCurrent(hDc,hRc);
		glClearColor(0.1,0.1,0.1,0.1);

		InitPacMan();

		LoadLevel(namelevels[0].m_String);
		LoadTextures();

		if(TestStartPoint()==false)
			MessageBox(0,"Not found start point","Error!",0);

		InitMonsters("monsters.ini");
		for(i=0;i<c_Monster;i++)
			game_Monster[i].tex=m_TexNmb[i];

		CalculateEat();

		live_Pacman=3;

		// Build fonts for screen modes
		switch(dm.dmPelsWidth){
		case 1280:
			BuildFont(0,-30);
			BuildFont(1,-70);
			BuildFont(2,-30);
			break;
		case 1024:
			BuildFont(0,-25);
			BuildFont(1,-50);
			BuildFont(2,-20);
			break;
		case 800:
			BuildFont(0,-20);
			BuildFont(1,-40);
			BuildFont(2,-18);
			break;
		case 640:
			BuildFont(0,-16);
			BuildFont(1,-30);
			BuildFont(2,-14);
			break;
		case 320:
			BuildFont(0,-8);
			BuildFont(1,-15);
			BuildFont(2,-7);
			break;
		}

		// Fmod init
		FSOUND_Init(44100,32,0);
		s_Stream[0]=FSOUND_Stream_Open("Data/PROSRALB.WAV",FSOUND_2D,0,0);
		s_Stream[1]=FSOUND_Stream_Open("Data/TAGB.WAV",FSOUND_2D,0,0);
		s_Stream[2]=FSOUND_Stream_Open("Data/PORVALB.WAV",FSOUND_2D,0,0);
		s_Stream[3]=FSOUND_Stream_Open("Data/CHAMPB.WAV",FSOUND_2D,0,0);
		//

		g_Menu=true;

		break;
	case WM_PAINT:
		glClear(GL_COLOR_BUFFER_BIT);
			DrawRect(-0.95,-0.95,0.95,0.95);

			TestObject();					// Check object
			CalculateMonster();				// Calculate monster position
			CalculatePacman();				// Calculate pacman position

			for(i=0;i<c_Monster;i++){
				if(game_Monster[i].die==false){
					if(game_Pacman.die==false)game_Monster[i].anit+=(float)0.1;
					if(game_Monster[i].anit>1){
						game_Monster[i].anit=0;
						game_Monster[i].tt++;
						if(game_Monster[i].tt>2)game_Monster[i].tt=0;
					}
				}
			}


			DrawLevel();					// Render walls, eat and bonuces

			for(i=0;i<c_Monster;i++)		// Render monsters
				if(game_Monster[i].die==false)
					DrawBox(game_Monster[i].xf,game_Monster[i].yf,0,0,game_Monster[i].tex+game_Monster[i].tt*2);
			
			if(game_Pacman.die==false)game_Pacman.anit+=(float)0.1;
			if(game_Pacman.anit>1){
				game_Pacman.anit=0;
				game_Pacman.tt++;
				if(game_Pacman.tt>2)game_Pacman.tt=0;
			}

			if(game_Pacman.bon==false)		// Normally pacman
				DrawBox(game_Pacman.xf,game_Pacman.yf,game_Pacman.angle,0,1+game_Pacman.tt*2);
			if(game_Pacman.bon)				// Demon-Pacman
				DrawBox(game_Pacman.xf,game_Pacman.yf,game_Pacman.angle,0,7+game_Pacman.tt*2);
			
			if(game_Pause==false&&g_Menu==false)
				if(game_Pacman.timebon>=0)game_Pacman.timebon-=(float)0.1;
					else game_Pacman.bon=false;

			if(c_Eat<=0){
				if(game_Pacman.s_win==false)
					if((rand()-16384)>0)FSOUND_Stream_Play(FSOUND_FREE,s_Stream[2]);
					else FSOUND_Stream_Play(FSOUND_FREE,s_Stream[3]);				
				game_Pacman.s_win=true;
			}

			if(game_Pacman.die)
				CenterPrint(37);		// Print when PacMan dead
			if(c_Eat<=0)
				CenterPrint(39);			// Print when eat=0
			if(game_Pause)
				CenterPrint(41);			// Print when game paused

			// Print number level
			PrintText(0,-0.95,0.96,0.75,0,0,"Level number = %d",n_Lvl);
			// Print count lives
			PrintText(0,0.5,0.96,0,0.75,0,"Lives count = %d",live_Pacman);
			// Print scores
			PrintText(0,-0.25,0.96,0.75,0.75,0,"Scores = %d",game_Scores);

			if(game_SScores>=1000){
				live_Pacman++;
				game_SScores=0;
			}

			// Game menu
			DrawMenu(g_Menu,0,0);

		SwapBuffers(hDc);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_KEYDOWN:
		switch(wParam){
		case VK_SPACE:
			Reload();
			break;
		case VK_ESCAPE:
			if(g_Menu==false)g_Menu=true;
			else g_Menu=false;
			break;
		case 'P':
			if(game_Pause)game_Pause=false;
			else game_Pause=true;
			break;
		}
		game_Pacman.keys[wParam]=true;
		break;
	case WM_KEYUP:
		game_Pacman.keys[wParam]=false;
	default:
		return DefWindowProc(hWnd,uMsg,wParam,lParam);
		break;
	}
}

WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd){
	WNDCLASS wc;
	HWND hWnd;
	MSG msg;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.lpszClassName="PacMan";
	wc.lpfnWndProc=WndProc;

	RegisterClass(&wc);

	InitPacMan();
	hWnd=CreateWindow("PacMan","PacMan game",WS_POPUP,0,0,dm.dmPelsWidth,dm.dmPelsHeight,0,0,0,0);

	ShowWindow(hWnd,SW_NORMAL);

	ShowCursor(false);

	while(msg.message!=WM_QUIT){
		GetMessage(&msg,NULL,0,0);
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}